
public class Chrono {
	private long tempo = 0;
	private boolean misurando = false;

	private long istanteInizio;

	public void start() {
		if (!misurando) {
			istanteInizio = System.nanoTime();
			misurando = true;
		}
	}

	public void stop() {
		if (misurando) {
			tempo += System.nanoTime()-istanteInizio;
			misurando=false;
		}
	}
	
	public void reset() {
		tempo=0;
		misurando=false;
	}
	
	public long getTempo() {
		if (!misurando) {
			return tempo;
		} else {
			return -1;
		}
	}

}
