
public class MergeSort {
	
	static void mergeSort (int[] a) {
		int[] aux = new int[a.length];
		mergeSort (a, 0, a.length-1, aux);
	}
	
	static void mergeSort (int[]a, int p, int r, int[] aux) {
		if (p<r) {
			int q=(p+r)/2;             //divide
			
			mergeSort (a, p, q, aux);  //impera
			mergeSort (a, q+1, r, aux);
			
			merge(a, p, q, r, aux);    //recombina
		}
	}
	
	static void merge (int[]a, int p, int q, int r, 
			           int[] aux) {
		for (int i=p ; i<=r; i++) {
			aux[i]=a[i];
		}
		int left=p;
		int right=q+1;
		for (int i=p; i<=r; i++) {
			if (left<=q && 
				 (right>r || aux[left]<=aux[right])
					) {
				a[i] = aux[left];
				left++;
			} else {
				a[i] = aux[right];
				right++;
			}
 		}
		
	}
	

}
